%CONVTEST  test the convergence of sfg.m

N = 4;
dx = 1/N;
[xg,yg] = meshgrid(0:dx:1, 0:dx:1);
x = xg(:);   y = yg(:);

% Linear
%p = 2*ones(size(xg));
%q = 4*ones(size(yg));
%uex = 2*xg + 4*yg;
% Quadratic
%p = 2*xg;
%q = 2*yg;
%uex = xg.^2 + yg.^2;
p = pi*cos(2*pi*x);
q = 2*y;
uex = (1/2)*sin(2*pi*x) + y.^2;


[alpha, tri] = sfg(x, y, p, q, [], uex(1));

figure(1); clf;
trimesh(tri, xg, yg, alpha);
xlabel('x');  ylabel('y');  zlabel('u_h');

err = abs(alpha - uex(:));
figure(2); clf;
trimesh(tri, xg, yg, err);
xlabel('x');  ylabel('y');  zlabel('error');
merr = max(err)
n2err = norm(err)
h = dx*sqrt(2)

[ntri, temp] = size(tri)
sum1 = 0;
for k = 1:ntri
    disp(['processing triangle ' num2str(k) ' of ' num2str((N^2*2))]);
    % indicies of nodes
    ni1 = tri(k,1);
    ni2 = tri(k,2);
    ni3 = tri(k,3);
    % location of nodes
    n1 = [x(ni1) y(ni1)];
    n2 = [x(ni2) y(ni2)];
    n3 = [x(ni3) y(ni3)];

    [cx,cy,cc] = lineartri(n1,n2,n3,alpha(ni1),alpha(ni2),alpha(ni3));

    fstr = ['((1/2)*sin(2*pi*x) + y.^2 - ' num2str(cx,16) '*x - ' num2str(cy,16) '*y - ' num2str(cc,16) ').^2'];
    f = inline(fstr,'x','y');
    sum1 = sum1 + dblquadtri(f,n1,n2,n3,1e-12);
end	

L2err = sqrt(sum1)

%merrs = [merrs merr]
%n2errs = [n2errs n2err]
%hs = [hs h]