function an = dblquadtri(f,p,q,r,tol,quadf)
% TODO: implement extra parametres to f (p1, p2, p3...)
  
  if (nargin < 5)
    tol = [];
  end
  if (nargin < 6)
    quadf = [];
  end    
    
  debugplot = 0;
  
  t = (p+q+r)/3;
  t1 = t(1);
  t2 = t(2);
  
  ymin = min([p(2),q(2),r(2)]);
  ymax = max([p(2),q(2),r(2)]);
  xmin = min([p(1),q(1),r(1)]);
  xmax = max([p(1),q(1),r(1)]);

  a1 = p(2) - q(2);
  b1 = -p(1) + q(1);
  c1 = -a1*p(1) - b1*p(2);
  if(a1*t1 + b1*t2 + c1 > 0)
    ineq1 = 1;
  else
    ineq1 = -1;
  end

  a2 = q(2) - r(2);
  b2 = -q(1) + r(1);
  c2 = -a2*r(1) - b2*r(2);
  if(a2*t1 + b2*t2 + c2 > 0)
    ineq2 = 1;
  else
    ineq2 = -1;
  end

  a3 = r(2) - p(2);
  b3 = -r(1) + p(1);
  c3 = -a3*r(1) - b3*r(2);
  if(a3*t1 + b3*t2 + c3 > 0)
    ineq3 = 1;
  else
    ineq3 = -1;
  end
  
  if (debugplot)
    figure(99); clf; hold on;
    plot(p(1), p(2), 'rx');
    plot(q(1), q(2), 'rx');
    plot(r(1), r(2), 'rx');
    axis([xmin xmax ymin ymax]);
  
    xt = [xmin xmax];
    plot(xt,(-a1*xt-c1)/b1, 'b:');
    plot(xt,(-a2*xt-c2)/b2, 'b:');
    plot(xt,(-a3*xt-c3)/b3, 'b:');
 
    dx = (xmax-xmin)/100
    dy = (ymax-ymin)/100
    [xx,yy] = meshgrid(xmin:dx:xmax, ymin:dy:ymax);
    
    z = ineq1*(a1*xx + b1*yy + c1) >= 0 & ...
        ineq2*(a2*xx + b2*yy + c2) >= 0 & ...
        ineq3*(a3*xx + b3*yy + c3) >= 0;

    figure(98); clf;
    pcolor(xx,yy,z);
    xlabel('x');  ylabel('y');
  end
  
  g = inline('f(x,y).*(ineq1*(a1*x+b1*y+c1)>=0&ineq2*(a2*x+b2*y+c2)>=0&ineq3*(a3*x+b3*y+c3)>=0)',...
             'x','y','f','a1','b1','c1','a2','b2','c2','a3','b3','c3',...
             'ineq1','ineq2','ineq3');
  
  an = dblquad(g, xmin, xmax, ymin, ymax, tol, quadf, ...
               f,a1,b1,c1,a2,b2,c2,a3,b3,c3,ineq1,ineq2,ineq3);
